/*
	The DIY Prime Wake Up Light
	electronics.nilshugo.se
	
	Copyright 2012 Christian Larsson 
	electronics@nilshugo.se
*/

#include <avr/io.h>
#include "alarmFunc.h"
#include "miscIO.h"
#include "buttons.h"
#include "dispControl.h"

volatile char alarmStatus;
volatile char alarmTriggered = 0;

void controlAlarm(long int totalDayTimeInSeconds, long int alarmTimeInSeconds){
	long int timeToAlarm;
	unsigned char dimmingValue;
	
	timeToAlarm = alarmTimeInSeconds - totalDayTimeInSeconds;
	if(timeToAlarm < 0)
		timeToAlarm += SECONDS_IN_DAY;

	if(timeToAlarm <= DIM_TIME_SECONDS){
		dimmingValue = DIM_MAX_VALUE - (timeToAlarm * DIM_MAX_VALUE / DIM_TIME_SECONDS);
		setNewDimmingSettingSlow(dimmingValue);
		
		if(timeToAlarm <= ALARM_TRIGG_MARGIN_SECONDS)
			setAlarmTriggered(ALARM_TRIGGERED);
	}
	
	return;
}

void setAlarmStatus(char status){
	if(status){
		alarmStatus = ALARM_ON;
		BUTTON_AND_ALARM_STATUS_PORT &= 0b01111111;
	}
	else{
		alarmStatus = ALARM_OFF;
		setAlarmTriggered(ALARM_OFF);
		setNewDimmingSettingSlow(DIM_MIN_VALUE);
		BUTTON_AND_ALARM_STATUS_PORT |= 0b10000000;
	}
	
	return;
}

void setAlarmTriggered(char alarmTriggered){
	if(alarmTriggered){
		DISP_AND_RELAY_CTRL_PORT	|= 0b01000000;
	}
	else{
		DISP_AND_RELAY_CTRL_PORT	&= 0b10111111;
	}
	
	return;
}

char isAlarmActive(void){
	return alarmStatus;
}